package net.t2code.t2codelib.SPIGOT.api.messages;

import me.clip.placeholderapi.PlaceholderAPI;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2C_PluginCheck;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class T2C_Replace {


    private static final Map<String, String> REPLACEMENTS = Map.of(
            "[ue]", "ü", "[UE]", "Ü",
            "[oe]", "ö", "[OE]", "Ö",
            "[ae]", "ä", "[AE]", "Ä",
            "[nl]", "\n"
    );

    public static String replace(String prefix, String text) {
        return replacePlaceholders(replaceLegacyColor(text), prefix, null, null);
    }

    public static String replace(String prefix, Player player, String text) {
        return replacePlaceholders(replaceLegacyColor(text), prefix, player, null);
    }

    public static Object replaceObject(String prefix, Object object) {
        return replaceObjectPlaceholders(object, prefix, null, null);
    }

    public static Object replaceObject(String prefix, Player player, Object object) {
        return replaceObjectPlaceholders(object, prefix, player, null);
    }

    public static List<String> replace(String prefix, List<String> texts) {
        return replacePlaceholdersInList(texts, prefix, null, null);
    }

    public static List<String> replace(String prefix, Player player, List<String> texts) {
        return replacePlaceholdersInList(texts, prefix, player, null);
    }

    public static List<String> replacePrice(String prefix, List<String> texts, String price) {
        return replacePlaceholdersInList(texts, prefix, null, price);
    }

    public static List<String> replacePrice(String prefix, Player player, List<String> texts, String price) {
        return replacePlaceholdersInList(texts, prefix, player, price);
    }

    public static String replacePrice(String prefix, String text, String price) {
        return replacePlaceholders(replaceLegacyColor(text), prefix, null, price);
    }

    public static String replacePrice(String prefix, Player player, String text, String price) {
        return replacePlaceholders(replaceLegacyColor(text), prefix, player, price);
    }

    public static String removeColorCode(String value) {
        return value.replaceAll("&[0-9a-fk-or]", "");
    }

    public static String replaceLegacyColor(String text) {
        return text.replaceAll("&([0-9a-fk-or])", "§$1");
    }

    public static String convertColorCode(String text) {
        return text.replaceAll("&([0-9a-fk-or])", "<$1>").replaceAll("§([0-9a-fk-or])", "<$1>");
    }

    public static Object replace(Object object, String placeholder, String replacement) {
        if (object instanceof String) {
            return ((String) object).replace(placeholder, replacement);
        } else if (object instanceof List) {
            List<String> list = (List<String>) object;
            List<String> output = new ArrayList<>();
            for (String item : list) {
                output.add(item.replace(placeholder, replacement));
            }
            return output;
        }
        return object;
    }

    private static String replacePlaceholders(String text, String prefix, Player player, String price) {
        text = text.replace("[prefix]", prefix);
        for (Map.Entry<String, String> entry : REPLACEMENTS.entrySet()) {
            text = text.replace(entry.getKey(), entry.getValue());
        }
        if (price != null) {
            text = text.replace("[price]", price);
        }
        if (player != null && T2C_PluginCheck.papi()) {
            text = PlaceholderAPI.setPlaceholders(player, text);
        }
        return text;
    }

    private static List<String> replacePlaceholdersInList(List<String> texts, String prefix, Player player, String price) {
        List<String> output = new ArrayList<>();
        for (String text : texts) {
            output.add(replacePlaceholders(replaceLegacyColor(text), prefix, player, price));
        }
        return output;
    }

    private static Object replaceObjectPlaceholders(Object object, String prefix, Player player, String price) {
        if (object instanceof String) {
            return replacePlaceholders(replaceLegacyColor((String) object), prefix, player, price);
        } else if (object instanceof List) {
            return replacePlaceholdersInList((List<String>) object, prefix, player, price);
        }
        return object;
    }
}
